
//****************************************************************************//
//*                                                                          *//
//* Filename:    infoctr.js                                                  *//
//* Purpose:     Add sort and filter buttons to the top of every table that  *//
//*              has more than a specified number of lines in it (including  *//
//*              the table header line)                                      *//
//*                                                                          *//
//*   During the build process this file will be concatenated to the end of  *//
//*   infoctr.js so it does not require a separate copyright notice.         *//
//*                                                                          *//
//* TRNOTE There is no translatable text in this file                        *//
//*                                                                          *//
//****************************************************************************//
//* Declare the global variables.  These variables are reset every time an   *//
//* information topic is loaded in the main panel.                           *//
var tableData;                          //* The data for all the tables on   *//
                                        //* the page.                        *//
var tables;                             //* The browser's list of tables     *//

//* Initialise the parent variables if they have not been set already.       *//
if (parent.DFHinit==null)
{
   parent.DFHlp         = new Array();  //* Learning path array              *//
   parent.DFHlppos      = -1;           //* Learning path position           *//
   getPrefs(); /* extract the prefs from the cookie*/
   //* Split the location search string into separate parameters.            *//
   var crumbs = unescape(parent.location.search.substring(1)).split('&');

   //* Initialise the parameters we are interested in                        *//
   var parm   = new Array();            //* The parameter array              *//
   parm['F'] = '';                      //* The initial file name            *//
   parm['I'] = '';                      //* The initial file identifier      *//

   //* Now extract the parameters from the string                            *//
   for (var i=0;i<crumbs.length;i++)
   {
      var p = crumbs[i].indexOf('=');
      if (p>-1)
         parm[crumbs[i].substring(0,p).toUpperCase()] = crumbs[i].substring(p+1).toLowerCase();
   }

//* Switch to the specified file if the F= parameter has been specified.  *//
   //not any more just go to book toc//
   if (parm['F']!="") {
         book="";
         if (parm['F'].indexOf(".htm")<0)   parm['F']=parm['F']+".htm"
         book = parm['F'].substring(0,5).toLowerCase();
         checkurl('../'+book+'/'+parm['F']);
            if (document.pageok!=0) {
               location.replace('../'+book+'/'+parm['F']);
            }
         else location.replace('../'+book+'/toc.htm');
   }

   //* Prepare to read the book index file if the identifier parameter has   *//
   //* been specified.                                                       *//
   // //not any more just go to book toc//
   if (parm['I']!="")
   {
      book="";
      if (parm['I'].indexOf(".htm")<0)   parm['I']=parm['I']+".htm"
      book = parm['I'].substring(0,5).toLowerCase();
      checkurl('../'+book+'/'+parm['I']);
         if (document.pageok!=0) {
            location.replace('../'+book+'/'+parm['I']);
         }
      else location.replace('../'+book+'/toc.htm');
   } 
}

//* Set a variable to indicate if the user is using Microsoft Internet       *//
//* Explorer.                                                                *//
var isIE = navigator.appName.indexOf("Microsoft") > -1;


//****************************************************************************//
//* Remember which directory we are working with when reading directory      *//
//* index files.  Every directory index file must begin with an invocations  *//
//* of this function to tell us to which directory it refers.  The parameter *//
//* is simply saved in the global variable "path" for use in any subsequent  *//
//* invocations of the function "id".                                        *//
//****************************************************************************//
function dir(directory)
{
   path = directory;
}


//****************************************************************************//
//* Look for an identifier in a directory index file and switch to the       *//
//* file that contains it.                                                   *//
//****************************************************************************//
function id(file,id,title)
{
    //* If this is the identifier we are looking for replace the current     *//
    //* contents of the frame with the file that contains the identifier.    *//
    if (id==parm['I']) {
            success=1;
            location.replace('../'+file.substring(0,5)+"/"+file+".htm");
    }
}


//****************************************************************************//
//*                                                                          *//
//*  Function modifyTables is called from the HTML to do all that is needed  *//
//*  to modify the HTML.  The actual contents of tables will only be         *//
//*  extracted for filtering and sorting if they are required.               *//
//*                                                                          *//
//****************************************************************************//
function modifyTables(document)
{
   //* Define the global variables.  Note that we must do this inside this   *//
   //* function since this file is imbedded globally whereas these variables *//
   //* must be reset for each topic that is loaded.                          *//
   tableData = new Array();            //* Keeps the data from all the       *//
                                       //* interesting tables on the page    *//

   //* Now create a list of all the tables on this page.  On MSIE we can do  *//
   //* this directly from the document.all collection but on Netscape        *//
   //* Navigator and other browsers we have to crawl around the document to  *//
   //* find them all.                                                        *//
   if (isIE)   {
         tables = document.all.tags("TABLE");  //* A list of every single table *//
                                            //* on the page                  *//
   }
   else
   {
      tables = new Array();
      findTables(document.body);
   }

   //* Modify each table (except the first table, which is the page heading  *//
   //* containing the file name and the book name) that has at least         *//
   //* 'iaTables' rows.  Note that this is an imperfect test since we have   *//
   //* not yet determined if there is a header row or a trailer row so we    *//
   //* will repeat the test in the function modifyTable once we have this    *//
   //* information.  It is still worth doing this test here to avoid having  *//
   //* to extract the inner HTML, which is a time-consuming process.         *//
   if (tables!=null )             {
         for (var i=1;i<tables.length;i++)     {
                 if (parent.dfhiaTables>0 & parent.dfhiaTables<=tables[i].rows.length) {
                                  modifyTable(tables[i], i);
                 }
         }
   }
}

//****************************************************************************//
//*                                                                          *//
//*  Add the control fields and buttons at the top of a table                *//
//*                                                                          *//
//****************************************************************************//
function modifyTable(tableObj, tableNumber)
{
   //*************************************************************************//
   //* Don't process this table if it has any spanned columns or any spanned *//
   //* rows, other than in the header row, if there is one, or in the last   *//
   //* row of the table.                                                     *//
   //*************************************************************************//
   //* Get the inner HTML for the whole table and split it into rows         *//
   var rows = tableObj.innerHTML.toUpperCase().split('</TR>');

   //* If the table starts with a comment containing the string              *//
   //* "non-interactive", then we won't make this table interactive.         *//
   if (  rows[0].indexOf("<!--")<3
      && rows[0].toLowerCase().indexOf("non-interactive")>-1
      )
      return;

   //* Determine whether or not the first row is a table description.  A     *//
   //* table description is rendered by the transform as a cell with a width *//
   //* of 100% spanning all the columns.                                     *//
   var descSize = (  rows[0].indexOf('<TH')<0
                  && rows[0].indexOf('WIDTH="100%"')>0
                  && rows[0].indexOf('COLSPAN=')>0
                  ) - 0;

   //* The next row in the table may be a header row.                        *//
   var hdrSize = (rows[descSize].indexOf('<TH')>-1) + descSize;

   //* The last row of the table may be a table note in which case we do not *//
   //* let it take part in sorting or filtering.                             *//
   var tlrSize = (rows[rows.length-2].indexOf('COLSPAN=')>0) - 0;

   //* Now check again that this table is large enough to be worth making it *//
   //* interactive.                                                          *//
   if (parent.dfhiaTables>rows.length-1-hdrSize-tlrSize) return;

   //* Check every row including the header but excluding the trailer to     *//
   //* make sure it does not have any spanned rows or columns.                *//
   for (var i=descSize;i<rows.length-tlrSize-1;i++)
      if (rows[i].indexOf("SPAN=")>0) return;

   //* Determine how many columns there are in the table by looking at the   *//
   //* first row after the header.                                           *//
   var columns = rows[hdrSize].split('</TD>').length-1;

   //* If the table has only one row and only one column then it has         *//
   //* probably been generated for a figure that requires a frame and we     *//
   //* should ignore it.                                                     *//
   if (rows.length==2 && columns==1) return;

   //*************************************************************************//
   //* O.K. we're going to make this table interactive - save some data      *//
   //* about it, add a new first row to contain a form and make the column   *//
   //* headers selectable for sorting.                                       *//
   //*************************************************************************//

   //* The table has passed the tests so now we can add it to the array and  *//
   //* save some of its properties.  The rest will not be created unless the *//
   //* user actually tries to interact with the table.  Note that the header *//
   //* size is set to one more than the current size since we will be adding *//
   //* another row to the table for the control panel.                       *//
   tableData[tableNumber] = new Object();
   tableData[tableNumber].hdrSize = hdrSize+1;
   tableData[tableNumber].tlrSize = tlrSize;
   tableData[tableNumber].columns = columns;

   //* There are two different ways to select the column for searching,      *//
   //* depending on whether or not the table has column headings.  If the    *//
   //* table has column headings, variable hdrSize has the value 1,          *//
   //* otherwise it is 0.                                                    *//
   var colSelect = "";
   if (hdrSize>descSize)
   {
      //**********************************************************************//
      //* The table has column headings so we modify the text in each        *//
      //* heading cell to make it a link to nowhere.  When it is selected it *//
      //* invokes the sort routine to sort the table on that column.         *//
      //**********************************************************************//

      //* Find the header row of the table.  Depending on how the SGML was   *//
      //* coded and transformed, the header may either be in the tHead       *//
      //* object or in tBodies[0].  If the header is in the tHead object     *//
      //* then there are no header rows in tBodies[0] and so we also need    *//
      //* to reset the value of hdrSize that we have already stored to 0.    *//
      var header = tableObj.tHead;
      if (header==null)
         header = tableObj.tBodies[0];
      else
         tableData[tableNumber].hdrSize = 0;
      
      //* Get the cells of the header row                                    *//
      header = header.rows[hdrSize-1].cells;

      //* Modify the HTML in each cell of the header row and generate a list *//
      //* of column headers for use in the dropdown box.                     *//
      var columnHTML = "";
      for (var col=0;col<columns;col++)
      {
         header[col].innerHTML
            = '<a href=""'
            +   ' onClick="sortTable('+tableNumber+','+col+');'
            +             'return false;'
            +            '"'
            +   mouseOver(_hov['tbColSort'])
            + '>'
            +   header[col].innerHTML
            + '</a>';
         columnHTML += "<OPTION>"
                     +   innerText(header[col])
                     + "</OPTION>";
      }
   }
   else
   {
      //**********************************************************************//
      //* The table does not have column headings, so we create a separate   *//
      //* selection box and "Go" button to sort the columns.                 *//
      //**********************************************************************//

      //* First build a list of column numbers for the selection box         *//
      for (var col=0;col<columns;col++)
         colSelect += '<option value="'+col+'">' + (col+1) + '</option>';

      //* Use the same list of options for the filter dropdown               *//
      var columnHTML = colSelect;

      //* Insert the selection box into a message and add a "Go" button      *//
      colSelect = '<br>'+message('tbSort'
                                ,'<select id="colSelect">'+colSelect+'</select>'
                                )
                + ' &nbsp; '
                + '<input type="button" value="'+_msg['tbGo']+'"'
                +       ' onClick="sortTable('+tableNumber
                + ',document.iat'+tableNumber+'.colSelect.value);">';
   }

   //*************************************************************************//
   //* Build the fields and buttons to be inserted in the new first row of   *//
   //* the table.                                                            *//
   //*************************************************************************//
   var form = '<FORM NAME="iat'+tableNumber+'"'
            +      ' style="margin:0px;padding:4px"'
            +      ' action="javascript:filterTable('+tableNumber+');">'
                //* Start with a message telling the user he can sort and    *//
                //* filter the table.                                        *//
            +   _msg['tbIAT1']
                //* If there is a header row tell him he can sort by         *//
                //* selecting the column header.                             *//
            +   (hdrSize>descSize?_msg['tbIAT2']:'')
                //* Tell him where to get more information.                  *//
            +   _msg['tbIAT3']
                //* Now include the column selection for sorting.  This will *//
                //* be null if there are column headers.                     *//
            +   colSelect
            +   '<BR>'
                //* Allow the user to enter the text or regular expression   *//
                //* and select the column for filtering.                     *//
            +   message('tbFilter'
                       ,'<INPUT TYPE="text" ID="txt" VALUE="">'
                       ,'<SELECT ID="filterCol">' + columnHTML + '</SELECT>'
                       )
            +   ' &nbsp; <INPUT TYPE="submit" VALUE="'+_msg['tbGo']+'">'
            +   ' &nbsp; &nbsp; '
                //* Include a button to reset the table to its original      *//
                //* state.                                                   *//
            +   '<INPUT TYPE="button" VALUE="'+_msg['tbReset']+'"'
            +         ' onClick="resetTable('+tableNumber+');">'
            +   '<BR>'
                //* Say how big the table is and how much is hidden.         *//
            +   message('tbTotal',rows.length-1-hdrSize-tlrSize) + '  '
            +   '<SPAN ID="iat'+tableNumber+'_msg">'
            +     message('tbHidden0')  //* Nothing hidden initially         *//
            +   '</SPAN>'
            + '</FORM>';

   //*************************************************************************//
   //* Add a new row to the start of the table (before any other row         *//
   //* including any header row).                                            *//
   //*************************************************************************//
   var newRow = tableObj.insertRow(0);

   //* Create a single cell in the new row and initialise it to span all     *//
   //* the columns, have a blue background (that ought to be in a style      *//
   //* sheet really), and contain the form we have just created.             *//
   var newCell = newRow.insertCell(0);
   newCell.colSpan = columns;
   newCell.bgColor = "#99ccff";
   newCell.innerHTML = form;

}

//****************************************************************************//
//*                                                                          *//
//*  Crawl around the document tree looking for tables                       *//
//*                                                                          *//
//****************************************************************************//
function findTables(object)
{
   //* Process the children of the object passed as a parameter              *//
   var child = object.firstChild;       //* Address the first child          *//
   while (child!=null)
   {
      //* If the child is a table, then add it to the global array that we   *//
      //* are creating.  Otherwise process its children.                     *//
      if (child.localName=="TABLE")
         tables[tables.length] = child;
      else
         findTables(child);
      //* Go on to the next sibling of this child                            *//
      child = child.nextSibling;
   }
}

//****************************************************************************//
//*                                                                          *//
//*  Sort a table on the specified column                                    *//
//*                                                                          *//
//****************************************************************************//
function sortTable(tableNumber,column)
{
   //* Initialise the table if it has not been initialised yet               *//
   var tBody = tables[tableNumber].tBodies[0];
   var table = tableData[tableNumber];
   if (table.data==null) initialiseTable(tBody,table);

   //* Do we have to sort the table, or can we just reverse the order of     *//
   //* the rows?                                                             *//
   if (column==table.sortCol)
      //* The table is already sorted on this column so we can just reverse  *//
      //* the order.                                                         *//
      table.ptrs.reverse();
   else
   {
      //* No, we really have to sort the table                               *//
      if (0==sort(table, column, table.colType[column]))
         return;
      table.sortCol = column;
   }

   //* Copy the contents of the table back to the document                   *//
   fillTable(table, tBody);
}

//****************************************************************************//
//*                                                                          *//
//*  Redisplay a table, filtering and sorting things along the way           *//
//*                                                                          *//
//****************************************************************************//
function filterTable(tableNumber)
{
   //* Initialise the table if it has not been initialised yet               *//
   var tBody = tables[tableNumber].tBodies[0];
   var table = tableData[tableNumber];
   if (table.data==null) initialiseTable(tBody,table);

   //* Get the form from the document                                        *//
   var form = document['iat'+tableNumber];

   //* Get the number of the column to be filtered from the form             *//
   var column = form.filterCol.selectedIndex;

   //* Get the regular expression to be used for filtering from the form     *//
   var filterString = form.txt.value;
   if (!parent.dfhiaTablesH)
      filterString = filterString.toLowerCase();

   //* Filter the table, if required                                         *//
   if (""!=filterString)
   {
      var ptrs    = table.ptrs;
      var newPtrs = new Array();

      //* Determine whether the user has entered a regular expression (a     *//
      //* string delimited by "/" characters) or a plain string, possibly    *//
      //* containing wildcard characters, and build a regular expression in  *//
      //* either case.                                                       *//
      var regexp = stringToRegExp(filterString);

      //* Filter the list, keeping only those rows in which the specified    *//
      //* column matches the regular expression we have generated.           *//
      for (var i=0; i<ptrs.length; i++)
         if (regexp.test(table.data[ptrs[i]][column].text))
            newPtrs[newPtrs.length] = ptrs[i];
      table.ptrs = newPtrs;

      //* Change the size of the output table                                *//
      resizeTable(table, tBody, table.ptrs.length, form);

      //* Copy the contents of the table back to the document                *//
      fillTable(table, tBody);
   }
}

//****************************************************************************//
//*                                                                          *//
//*  Convert a string into a regular expression.  If the string starts and   *//
//*  ends with "/" characters then it is already a string equivalent of a    *//
//*  regular expression and all that is required is to invoke the regular    *//
//*  expression constructor with the contents of the string.  Otherwise the  *//
//*  string is not a regular expression but it may contain wildcard          *//
//*  characters * and ? as used by NetQuestion.  Any special character used  *//
//*  by regular expressions is escaped using a single backslash (though it   *//
//*  appears as a double backslash in the code below since it has to be      *//
//*  escaped in a JavaScript string).  An asterisk is converted into ".*"    *//
//*  and a question mark is converted into ".", as required in regular       *//
//*  expressions.  Finally the regular expression constructor is invoked.    *//
//*                                                                          *//
//****************************************************************************//
function stringToRegExp(string)
{
   //* If this is a string equivalent of a regular expression just pass it   *//
   //* to the regular expression constructor (without the enclosing          *//
   //* slashes).                                                             *//
   if (  string.substring(0,1)=="/"
      && string.substring(string.length-1)=="/"
      )
      return new RegExp(string.substring(1,string.length-1));

   //* Examine the string one character at a time                            *//
   for (var p=0;p<string.length;p++)
   {
      var c = string.substr(p,1);       //* Isolate the next character       *//
      if ("/|.+()[]{}^$\\".indexOf(c)>-1) //* Is it a regular expn char?     *//
      {                                 //* If so, add an escape character   *//
         string = string.substring(0,p) + "\\" + string.substring(p);
         p++;
      }
      else if (c=="*")                  //* Is it an asterisk representing   *//
      {                                 //* any string?                      *//
         string = string.substring(0,p) + "." + string.substring(p);
         p++;
      }
      else if (c=="?")                  //* Is it a query representing a     *//
      {                                 //* single character?                *//
         string = string.substring(0,p) + "." + string.substring(p+1);
      }
   }
   //* Return the converted string                                           *//
   return new RegExp(string)
}

//****************************************************************************//
//*                                                                          *//
//*  Reset the table to its original state                                   *//
//*                                                                          *//
//****************************************************************************//
function resetTable(tableNumber)
{
   //* Initialise the table if it has not been initialised yet               *//
   var tBody = tables[tableNumber].tBodies[0];
   var table = tableData[tableNumber];
   if (table.data==null) initialiseTable(tBody,table);

   //* Get the form                                                          *//
   var form = document['iat'+tableNumber];

   //* Reset the array of pointers to the rows being displayed               *//
   resetPtrs(table);

   //* Change the size of the output table                                   *//
   resizeTable(table, tBody, table.data.length, form);

   //* Copy the contents of the table back to the document                   *//
   fillTable(table, tBody);
}

//****************************************************************************//
//*                                                                          *//
//*  Initialise the table                                                    *//
//*                                                                          *//
//****************************************************************************//
function initialiseTable(tBody,table)
{
   //* Extract the data from the table                                       *//
   table.data = extractRows(tBody,table);

   //* Define an array of pointers to the rows of the table that are         *//
   //* currently displayed.                                                  *//
   table.ptrs = new Array();
   resetPtrs(table);

   //* Find out which, if any, columns of the table are numeric and get the  *//
   //* important attributes of the cells in the first row.                   *//
   table.colType = new Array();
   table.attrs = new Array();
   var lastRow = tBody.rows.length-table.tlrSize-table.hdrSize-1;
   for (var cell=0; cell<tBody.rows[lastRow].cells.length; cell++)
   {
      //* The function extractRows will have converted each cell to its      *//
      //* numeric equivalent, working down each column until a non-numeric   *//
      //* cell is encountered.  Thus the column can be sorted numerically if *//
      //* and only if there is a numeric value associated with the cell in   *//
      //* the last row of the table.                                         *//
      table.colType[cell] = ( isNaN(table.data[lastRow][cell].number)
                            ? 'text'
                            : 'number'
                            );

      //* Define an object to contain the attributes of the cells in each    *//
      //* column.  Note that we will use these attributes for every cell in  *//
      //* the column.  This could be wrong.  If a cell has attributes that   *//
      //* differ from those in the first cell these will be lost whenever    *//
      //* the table is filtered, sorted or reset.  We could avoid this by    *//
      //* extracting the attributes for every cell in every row and carrying *//
      //* them along with the data, but this seems a bit of overkill.        *//
      table.attrs[cell] = new Object();
      //* Get a shortcut to the cell in the first row and extract its        *//
      //* attributes.                                                        *//
      var tcell = tBody.rows[table.hdrSize].cells[cell];
      table.attrs[cell].width  = tcell.width;
      table.attrs[cell].vAlign = tcell.vAlign;
      table.attrs[cell].align  = tcell.align;
   }
}

//****************************************************************************//
//*                                                                          *//
//*  Create and return a two-dimensional array of the inner HTML from the    *//
//*  cells in a table body                                                   *//
//*                                                                          *//
//****************************************************************************//
function extractRows(tableBody,table)
{
   //* Get the size of the header                                            *//
   var hdrSize = table.hdrSize;

   //* Define an array to contain the rows of the table.  Note that the      *//
   //* indexes of this array will differ from the rows of the HTML table by  *//
   //* 'hdrsize'.  I.e. element 0 of array rowArray corresponds to row       *//
   //* 'hdrsize' in the table, and so on.                                    *//
   var rowArray = new Array();          //* The rows of the table            *//

   //* The array numericCol has one element for each column in the table and *//
   //* is used to determine whether or not all the cells in the body of the  *//
   //* table in the corresponding column begin with numeric values.  To do   *//
   //* this each element of the array is initialised to the value "true" and *//
   //* each cell in each column is tested using the built-in function        *//
   //* parseFloat until a cell is found that does not begin with a number,   *//
   //* whereafter the cells in that column are no longer tested.             *//
   var numericCol = new Array();
   for (var cell=0; cell<tableBody.rows[hdrSize].cells.length; cell++)
      numericCol[cell] = true;

   //* Add each row of the table body to the array                           *//
   for (var row=hdrSize; row<tableBody.rows.length-table.tlrSize; row++)
   {
      //* Define an array to contain the cells in this row of the table.     *//
      var cellArray = new Array();      //* The cells in the row             *//

      //* Define a shortcut to the cells of the row.                         *//
      var htmlRow = tableBody.rows[row].cells;

      //* Add each cell of the table row to the array of cells               *//
      for (var cell=0; cell<tableBody.rows[row].cells.length; cell++)
      {
         //* Define a new object to contain this cell.  Note that we have to *//
         //* save both the HTML and the text.  The HTML is used when         *//
         //* rebuilding the table and the text is used when sorting or       *//
         //* filtering the table.  We will also save the numeric value of    *//
         //* the cell if it is required for numeric sorting.                 *//
         cellArray[cell] = new Object();
         cellArray[cell].html = htmlRow[cell].innerHTML;
         cellArray[cell].text = innerText(htmlRow[cell]);

         //* If the user has chosen to use case-insensitive sorting and      *//
         //* filtering, the text is converted to lower case.                 *//
         if (!parent.dfhiaTablesH)
            cellArray[cell].text = cellArray[cell].text.toLowerCase();

         //* If every cell in this column has been numeric so far, then test *//
         //* this cell to see if it too is numeric.  If it is not then set   *//
         //* the corresponding element of the array numericCell to false so  *//
         //* that no more cells are tested in this column.                   *//
         if (numericCol[cell])
         {
            cellArray[cell].number = parseFloat(innerText(htmlRow[cell]));
            if (isNaN(cellArray[cell].number))
               numericCol[cell] = false;
         }
      }
      //* Add the array of cells that we have just constructed as a new      *//
      //* element in array rowArray, starting with element 0 for row         *//
      //* 'hdrsize'.                                                         *//
      rowArray[row-hdrSize] = cellArray;
   }

   return rowArray;
}

//****************************************************************************//
//*                                                                          *//
//*  Some browsers do not provide the property "innerText" so we have to     *//
//*  obtain it by removing tags from the innerHTML.                          *//
//*                                                                          *//
//****************************************************************************//
function innerText(object)
{
   if (object.innerText!=null)
      return object.innerText;

   var HTML = object.innerHTML;

   //* Define the returned variable and initialise it as an empty string     *//
   var text = "";

   //* Define a pointer into the HTML string                                 *//
   var p = 0;

   //* Look for the first tag in the HTML                                    *//
   var q = HTML.indexOf("<");
   while (q>-1)                         //* Iterate while there are tags     *//
   {
      text += HTML.substring(p,q);      //* Extract the text                 *//
      p = HTML.indexOf(">",q)+1;        //* Find the end of the tag          *//
      q = HTML.indexOf("<",p);          //* Look for the next tag            *//
   }

   //* Return the text we have collected and the rest of the HTML            *//
   return text + HTML.substring(p)
}

//****************************************************************************//
//*                                                                          *//
//*  Reset the row pointers to restore the table to its original condition   *//
//*                                                                          *//
//****************************************************************************//
function resetPtrs(table)
{
   //* Reset the array or row pointers to point to every row in the body of  *//
   //* the table.                                                            *//
   for (i=0;i<table.data.length;i++) table.ptrs[i] = i;

   //* Indicate that no column is currently sorted.                          *//
   table.sortCol = -1;
}

//****************************************************************************//
//*                                                                          *//
//*  Resize a table                                                          *//
//*                                                                          *//
//****************************************************************************//
function resizeTable(table, tBody, newBodySize, form)
{
   //* Get the size of the header                                            *//
   var hdrSize = table.hdrSize;

   //* Calculate how many rows need to be added to the table                 *//
   var rowDeficit = newBodySize + hdrSize + table.tlrSize  //* New size      *//
                  - tBody.rows.length;                     //* Current size  *//

   //*************************************************************************//
   //* Add some rows if the table is too small                               *//
   //*************************************************************************//
   for (i=0; i<rowDeficit; i++)
   {
      //* Define a new row immediately after the header and fill it with     *//
      //* cells.  Set the cell attributes from the attributes gathered from  *//
      //* the first data row in the table.                                   *//
      var newRow = tBody.insertRow(hdrSize);
      for (var cell=0; cell<table.columns; cell++)
      {
         var newCell = newRow.insertCell(cell);
         newCell.width  = table.attrs[cell].width;
         newCell.vAlign = table.attrs[cell].vAlign;
         newCell.align  = table.attrs[cell].align;
      }
   }

   //*************************************************************************//
   //* Delete some rows if the table is too big                              *//
   //*************************************************************************//
   for (i=0; i<-rowDeficit; i++)
      tBody.deleteRow(hdrSize);

   //*************************************************************************//
   //* Write a message to say how many rows are now hidden                   *//
   //*************************************************************************//
   //* Calculate how many rows are hidden                                    *//
   var hiddenRows = table.data.length - table.ptrs.length;
   //* Find the message we want to change                                    *//
   var msg = document.getElementById(form.name+"_msg");
   //* Reset the contents of the element.  Note that we have to use the      *//
   //* innerHTML property because not all browsers support innerText.        *//
   msg.innerHTML =
      ( hiddenRows==0 ? message('tbHidden0')
      : hiddenRows==1 ? message('tbHidden1')
      :                 message('tbHiddenn',hiddenRows)
      );
}

//****************************************************************************//
//*                                                                          *//
//*  Refill the table from the rows pointed to by 'table.ptrs'.              *//
//*                                                                          *//
//****************************************************************************//
function fillTable(table, tBody)
{
   //* Get the size of the header                                            *//
   var hdrSize = table.hdrSize;

   //* Fill each row of the body of the table from the saved HTML            *//
   for (var row=hdrSize; row<tBody.rows.length-table.tlrSize; row++)
   {
      var htmlRow = tBody.rows[row].cells;
      var tableRow = table.data[table.ptrs[row-hdrSize]];
      //* Fill each cell of the row from the saved HTML                      *//
      for (var cell=0; cell<table.columns; cell++)
         htmlRow[cell].innerHTML = tableRow[cell].html;
   }
}

//****************************************************************************//
//*                                                                          *//
//*  Sort the visible rows                                                   *//
//*                                                                          *//
//****************************************************************************//
function sort(table, column, field)
{
   //* Define a shortcut to the pointers                                     *//
   var ptrs = table.ptrs;

   //* If this is a large table, ask the user if he really wants to do this. *//
   if (ptrs.length>1000)
      if (!confirm(message('tbLarge',ptrs.length)))
         return 0;

   //* Insert each pointer into the correct sequence                         *//
   for (var i=1;i<ptrs.length;i++)
   {
      //* Pointers 0 to i-1 are assumed to be correctly sorted.  Now insert  *//
      //* pointer i into its correct position.                               *//
      var ptri = ptrs[i];               //* Copy the pointer                 *//
      var item = table.data[ptri][column][field]; //* Get the data item      *//

      //* Find where to insert pointer i by repeatedly bisecting the range   *//
      //* of pointers that have already been sorted.                         *//
      var l = 0; var r = i;             //* Initialise the boundaries        *//
      while (r>l)
      {
         var m = l+r;                   //* Find the mid-point between the   *//
         m = (m-m%2)/2;                 //* two boundaries                   *//
         //* Compare the data item with the mid-point of the sequence        *//
         if (item>=table.data[ptrs[m]][column][field])
            l = m+1;                    //* Reset the lower boundary         *//
         else
            r = m;                      //* Reset the upper boundary         *//
      }

      //* We've found where the pointer should be inserted - place it        *//
      for (l=i;l>r;l--)                 //* Shuffle up all the pointers      *//
         ptrs[l] = ptrs[l-1];           //* above the insertion point        *//
      ptrs[r] = ptri;                   //* Insert pointer i at position r   *//
   }
   return 1
}



//* Define some arrays used to hold text strings.  These arrays are indexed  *//
//* by the string name (enclosed in double quotation marks) of the array     *//
//* item.                                                                    *//
var _acc = new Array();         //* Array of access keys                     *//
var _tab = new Array();         //* Array of tab text                        *//
var _hov = new Array();         //* Array of tab text for window status      *//
var _msg = new Array();         //* Array of messages                        *//
var _txt = new Array();         //* Array of text inserts                    *//
var _alt = new Array();         //* Array of alternate text for images       *//

//*--------------------------------------------------------------------------*//
//*     Text messages and buttons used for interactive tables                *//
//*--------------------------------------------------------------------------*//
_msg['tbBadVal']  = "Please enter '0' (zero) or an integer greater than 1";
_msg['tbIAT1']    = "You can sort and filter the information in this table.  ";
_msg['tbIAT2']    = "Select a column heading to sort on that column.  ";
_msg['tbIAT3']    = "For more information, see <A HREF='../infoc/tables.html#HDRICHLPUT'>Interactive tables</A>.  ";
//* TRNOTE The string %1% in the following message is replaced by a          *//
//* selection box containing the number of the column for the sort           *//
_msg['tbSort']    = "Sort on column %1%";
//* TRNOTE The string %1% in the following message is replaced by a text box *//
//* TRNOTE in which the user enters the string to be searched for, and the   *//
//* TRNOTE string %2% is replaced by a selection box containing the number   *//
//* TRNOTE of the column in which to search.                                 *//
_msg['tbFilter']  = "Search for %1% in column %2%";
_msg['tbGo']      = "Go";
_msg['tbReset']   = "Reset";
_msg['tbTotal']   = "There are %1% rows in the body of this table.";
_msg['tbHidden0'] = "No rows are currently hidden";
_msg['tbHidden1'] = "One row is hidden";
_msg['tbHiddenn'] = "%1% rows are hidden";
_msg['tbLarge']   = "There are %1% rows to be sorted.  This could take a long time.  "
                  + "Do you wish to continue?";
_hov['tbColSort'] = "Sort on this column";
//*--------------------------------------------------------------------------*//
//* TRNOTE End of text fields for interactive tables                         *//
//*--------------------------------------------------------------------------*//

//****************************************************************************//
//*                                                                          *//
//*  Build a message containing inserted text                                *//
//*                                                                          *//
//****************************************************************************//
function message(msgKey)
{
   //* Get the text of the message                                           *//
   var msg = _msg[msgKey];
   //* Replace each message variable by its corresponding text               *//
   for (var a=1;a<arguments.length;a++)
   {
      var p = msg.indexOf("%"+a+"%");
      msg = msg.substring(0,p)
          + arguments[a]
          + msg.substring(p+3);
   }
   //* Return the modified message                                           *//
   return msg
}


//****************************************************************************//
//*                                                                          *//
//*  Create attributes for the onMouseOver and onMouseOut event handlers     *//
//*                                                                          *//
//****************************************************************************//
function mouseOver(hoverText)
{
   return ' onMouseOver="window.status=\''+gsub(hoverText,"'","\\'")+'\';return true;"'
        + ' onMouseOut="window.status=\'\';return true;"'
}


//****************************************************************************//
//*                                                                          *//
//*  The gsub function performs global substitution.  If regular expressions *//
//*  worked as advertised on all browsers then this would not be required.   *//
//*                                                                          *//
//****************************************************************************//
function gsub(string,a,b)
{
   var p = 0;
   while (true)
   {
      p = string.indexOf(a,p);
      if (p<0) return string;
      string = string.substring(0,p) + b + string.substring(p+a.length);
      p = p + b.length;
   }
   return string
}


//****************************************************************************//
//*                                                                          *//
//*  Add the book or learning path links to the bottom of the page           *//
//*                                                                          *//
//****************************************************************************//
function setLinks(toc,prev,next,index)
{
   //* Call modifyTables to make the tables in the current document          *//
   //* interactive.                                                          *//
   modifyTables(document);

   //* If we were on a learning path but the current page is not on the      *//
   //* path, presumably because the user has taken a link off to another     *//
   //* page, then clear the learning path flag so that the links at the foot *//
   //* of the page act normally.                                             *//
   for (var l=0;l<parent.DFHlp.length;l++)
   {
      if (location.href.indexOf(parent.DFHlp[l].substring(3))>-1)
         parent.DFHlppos = l;
   }
   if (parent.DFHlppos>-1
    && location.href.indexOf(parent.DFHlp[parent.DFHlppos].substring(3))<0
      )
      parent.DFHlppos = -1;

   //* Add the appropriate links to the bottom of the page.  Normally the    *//
   //* links go to the contents of the book, the previous and next topics in *//
   //* the book, and to the index of the book.   If, however, we are in a    *//
   //* learning path then the links go to the introduction to the path, the  *//
   //* previous and next topics in the path, and to the summary of the       *//
   //* learning path.                                                        *//
   document.write(
      '<br><hr>'
    + '<p align="center">'
    + (parent.DFHlppos>-1               //* Are we on a learning path?       *//
      ?   //******************************************************************//
          //* This is a learning path - create links to the introduction,    *//
          //* the previous and next topics, and to the summary.              *//
          //******************************************************************//

          //* Unless this is the introduction, create links to the           *//
          //* introduction and to the previous topic in the learning path.   *//
          (parent.DFHlppos>0
          ?  '<a href="'+parent.DFHlp[0]+'">'
           +   '<img src="../images/toc.gif" style="border:0" alt="Overview">'
           + '</a>'
           + ' &nbsp; '
           + '<a href="'+parent.DFHlp[parent.DFHlppos-1]+'"'
           +   ' onClick="parent.DFHlppos--;return true;"'
           + '>'
           +   '<img src="../images/prev.gif" style="border:0" alt="Previous topic">'
           + '</a>'
           + ' &nbsp; '
          : ''
          )
          //* Unless this is the summary, create links to the next topic in  *//
          //* the learning path and to the summary.                          *//
        + (parent.DFHlppos<parent.DFHlp.length-1
          ?  '<a href="'+parent.DFHlp[parent.DFHlppos+1]+'"'
           +   ' onClick="parent.DFHlppos++;return true;"'
           + '>'
           +   '<img src="../images/next.gif" style="border:0" alt="Next topic">'
           + '</a>'
           + ' &nbsp; '
           + '<a href="'+parent.DFHlp[parent.DFHlp.length-1]+'">'
           +   '<img src="../images/idx.gif" style="border:0" alt="Summary">'
           + '</a>'
          : ''
          )
      
       :  //******************************************************************//
          //* We are not on a learning path so just create links to the      *//
          //* table of contents, the next and previous topics in the book,   *//
          //* and to the index, if there is one.                             *//
          //******************************************************************//

          //* Create a link to the table of contents.                        *//
          '<a href="'+toc+'">'
        +   '<img src="../images/toc.gif" style="border:0" alt="Contents">'
        + '</a>'
        + ' &nbsp; '
          //* Create a link to the previous topic in the book.               *//
        + '<a href="'+prev+'">'
        +   '<img src="../images/prev.gif" style="border:0" alt="Previous page">'
        + '</a>'
        + ' &nbsp; '
          //* Create a link to the next topic in the book.                   *//
        + '<a href="'+next+'">'
        +   '<img src="../images/next.gif" style="border:0" alt="Next page">'
        + '</a>'
        + ' &nbsp; '
          //* Create a link to the index of the book.                        *//
        + '<a href="'+index+'">'
        +   '<img src="../images/idx.gif" style="border:0" alt="Index">'
        + '</a>'
      )
    + '</p>');
}

function readcook() {

   var cookie = getCookie("DFHIC");
   var crumbs2 = unescape((cookie+'&'+location.search.substring(1))).split('&');
   var parm2   = new Array();

   //* Initialise the parameters we are interested in                           *//
   parm2['PREF'] = '';              //* General preferences                      *//

   //* Now extract the parameters from the string                               *//
   for (var i=0;i<crumbs2.length;i++)
   {
      var p = crumbs2[i].indexOf('=');
      if (p>-1)
         parm2[crumbs2[i].substring(0,p).toUpperCase()] = crumbs2[i].substring(p+1);
   }

   //* Copy the parameters into a more convenient form                          *//
   parent.PREF2 = parm2['PREF'];
   
}

//****************************************************************************//
//*                                                                          *//
//*  getCookie retrieves a cookie.                                           *//
//*                                                                          *//
//****************************************************************************//
function getCookie(cookieName)
{
   //* Get all the cookies                                                   *//
   var cookies = parent.document.cookie+";";
   //* Look for the cookie we want                                           *//
   var pos = cookies.indexOf(cookieName+"=");
   //* Return the cookie if we found it or an empty string otherwise         *//
   if (pos>-1)
   {
      pos += cookieName.length+1;      //* Step over the name and the equals *//
      return cookies.substring(pos,cookies.indexOf(";",pos));
   }
   else
      return "";
}

//****************************************************************************//
//*                                                                          *//
//*  Extract the preferences from variable PREF.  See the comment in the     *//
//*  heading for setprefs for a description of the preference string.        *//
//*                                                                          *//
//****************************************************************************//
function getPrefs()
{
   /*set defaults*/
   parent.DFHinit       = 1;            //* Initialisation done              *//
   parent.dfhiaTables   = 10;           //* Minimum interactive table size   *//
   parent.dfhiaTablesH  = true;         //* Case-sensitive search?           *//
   parent.dfhSyntaxType = "RR";         //* Type of syntax display           *//
   parent.dfhImageType  = "gif";        //* Display images                   *//
   parent.PREF2="";
   readcook(); /* readin the cookie with the prefs in*/
   if (parent.PREF2!="")
   {
      //* Get and check the type of syntax diagrams to be displayed          *//
      parent.dfhSyntaxType = parent.PREF2.substring(0,2);
      if ('RR BN DD'.indexOf(parent.dfhSyntaxType)<0)
         parent.dfhSyntaxType = "RR";
      //* Get the type of images to be displayed                             *//
      parent.dfhImageType  = parent.PREF2.substring(2,3)==2 ? "text" : "gif";
      //* Get more options if the string is longer than 3 characters         *//
      //* Get the minimum size of interactive tables and whether or not   *//
         //* table searching is to be case-sensitive.                        *//
        a=checkIaTables(parent.PREF2.substring(3,6),10);
         parent.dfhiaTables    = a
         parent.dfhiaTablesH   = parent.PREF2.substring(6,7)=="1";
         //* Get more options if the string is longer than 11 characters.    *//
      
   }
   else {
      /*there was no cookie so lets store one*/
      setPrefs(0);
   }

}

function checkIaTables(value,def) { 
   r=getInt(value,def, 0,999) ;
   return r;
   }

//****************************************************************************//
//*                                                                          *//
//*  Store Preferences in the cookie                                         *//
//*                                                                          *//
//*  The format of the PREF value in the cookie is one of the following:     *//
//*                                                                          *//
//*       SSITTTHNNNN                                                        *//
//*  where:                                                                  *//
//*    SS   is the two-character indicator of the syntax diagram preference. *//
//*         It must be one of "RR", "BN" or "DD".                            *//
//*    I    is the one-digit indicator of the image preference.  "1" means   *//
//*         that the GIF is to be displayed; "2" means that the alternate    *//
//*         text is to be displayed.                                         *//
//*    TTT  is the number of rows required to interactivate a table          *//
//*    H    is 1 if table sorting and filtering is case-sensitive            *//
//****************************************************************************//
function setPrefs(level)
{
   //* First assign the variable associated with the checkbox                *//
      //* Now store the preferences in the cookie                               *//
   parent.PREF2 = parent.dfhSyntaxType                     //* Type of syntax display       *//
        + ( parent.dfhImageType=="text" ? 2 : 1 )  //* Display images or HTML desc. *//
        + "000".substring((""+parent.dfhiaTables).length)+parent.dfhiaTables
        + (parent.dfhiaTablesH ? 1 : 0)
   /*(if (level==0) setCookie("DFHIC",escape("PREF="+parent.PREF2),level);     */
   if (1==1) setCookie("DFHIC",escape("PREF="+parent.PREF2),level);
}


//****************************************************************************//
//*                                                                          *//
//*  setCookie saves a cookie.                                               *//
//*                                                                          *//
//****************************************************************************//
function setCookie(cookieName,cookieValue,level)
{
   //* Set the cookie to expire in a year's time                             *//
   var nextyear = new Date();
   nextyear.setFullYear(nextyear.getFullYear() + 1);
   parent.document.cookie = cookieName + "=" + cookieValue + ";"
                   + "expires=" + nextyear.toGMTString() + ";";
}



//****************************************************************************//
//*                                                                          *//
//*  Convert a character string into an integer.                             *//
//*                                                                          *//
//****************************************************************************//
function getInt(value,def,min,max)
{
   value = parseInt(value,10);
   if (isNaN(value))  return def;
   if (value<min)     return min;
   if (value>max)     return max;
   return value;
}

     
document.pageok=-1;
var requester;
function seeifmissingpage() {
   var item;
    if (requester.readyState == 4) {
        if (requester.status == 200 || requester.status==0) {
            xml=requester.responseText;
            if (xml.indexOf("<body dir=\"ltr\"><p>The topic that you have requested is not available.")>0) {
               document.pageok=0;
            }
            else document.pageok=1;
        } else {
            document.pageok=-2;
        }
    }
}
function checkurl(url) {
            	requester = false;
                if(window.XMLHttpRequest && !(window.ActiveXObject)) {
                	try {
            			requester = new XMLHttpRequest();
                    } catch(e) {
            			requester = false;
                    }
                } else if(window.ActiveXObject) {
                   	try {
                    	requester = new ActiveXObject("Msxml2.XMLHTTP");
                  	} catch(e) {
                    	try {
                      		requester = new ActiveXObject("Microsoft.XMLHTTP");
                    	} catch(e) {
                      		requester = false;
                    	}
            		}
                }
            	if(requester) {
            		requester.onreadystatechange = seeifmissingpage;
            		requester.open("GET", url, false);
            		try {requester.send("");}
                    catch(e) {
                    }
            	}
}


//****************************************************************************//
//* End of file                                                              *//
//****************************************************************************//


